<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IntCodeAttr2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IntCodeAttr2 extends AbstractStructArrayBase
{
    /**
     * The RoomType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IntCodeAttr[]
     */
    public $RoomType;
    /**
     * Constructor method for ArrayOfJPSOAP_IntCodeAttr2
     * @uses ArrayOfJPSOAP_IntCodeAttr2::setRoomType()
     * @param \StructType\JPSOAP_IntCodeAttr[] $roomType
     */
    public function __construct(array $roomType = array())
    {
        $this
            ->setRoomType($roomType);
    }
    /**
     * Get RoomType value
     * @return \StructType\JPSOAP_IntCodeAttr[]|null
     */
    public function getRoomType()
    {
        return $this->RoomType;
    }
    /**
     * Set RoomType value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr[] $roomType
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr2
     */
    public function setRoomType(array $roomType = array())
    {
        foreach ($roomType as $arrayOfJPSOAP_IntCodeAttr2RoomTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IntCodeAttr2RoomTypeItem instanceof \StructType\JPSOAP_IntCodeAttr) {
                throw new \InvalidArgumentException(sprintf('The RoomType property can only contain items of \StructType\JPSOAP_IntCodeAttr, "%s" given', is_object($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem) ? get_class($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem) : gettype($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem)), __LINE__);
            }
        }
        $this->RoomType = $roomType;
        return $this;
    }
    /**
     * Add item to RoomType value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr $item
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr2
     */
    public function addToRoomType(\StructType\JPSOAP_IntCodeAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IntCodeAttr) {
            throw new \InvalidArgumentException(sprintf('The RoomType property can only contain items of \StructType\JPSOAP_IntCodeAttr, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoomType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomType
     */
    public function getAttributeName()
    {
        return 'RoomType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
